<?php
if(isset($_POST['popup_submit_bttn']) && isset( $_POST['ism_admin_nonce'] ) && wp_verify_nonce( $_POST['ism_admin_nonce'], 'ism_admin_nonce' )){
	ism_return_arr_update( 'popup' );
}
//default settings
$meta_arr = ism_return_arr_val( 'popup' );
?>
<div class="metabox-holder indeed">
	<form method="post">

		<input type="hidden" value="<?php echo wp_create_nonce( 'ism_admin_nonce' );?>" name="ism_admin_nonce" />

		<?php
			//sm checkboxes
			ism_print_list_checkboxes($meta_arr, 'popup', 'popup_submit_bttn');

			//STANDARD TEMPLATES
        	ism_return_standard_templates_html( 'popup_template', $meta_arr['popup_template'], 'popup_submit_bttn' );

        	//SPECIAL TEMPLATES
        	ism_return_special_templates_html( 'popup_template', $meta_arr['popup_template'], 'popup_submit_bttn' );
        ?>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Display Options:', 'indeed-social-media');?></label>
		            </h3>
		            <div class="inside">
		            	<table class="form-table ism-content">
			                <tbody>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('List Align:', 'indeed-social-media');?>
										<span class="ism-info"><?php esc_html_e('Select how the the list should be displayed.', 'indeed-social-media');?></span>
		                            </th>
		                            <td>
		                                <?php
		                                    $checked = ism_checkSelected('vertical', $meta_arr['popup_list_align'], 'radio');
		                                ?>
		                                <input type="radio" name="popup_list_align" value="vertical" <?php echo $checked;?>  /><span class="indeedcrlabel"><?php esc_html_e('Vertical', 'indeed-social-media');?></span>
		                                <?php
		                                    $checked = ism_checkSelected('horizontal', $meta_arr['popup_list_align'], 'radio');
		                                ?>
		                                <input type="radio" name="popup_list_align" value="horizontal" <?php echo $checked;?>  /><span class="indeedcrlabel"><?php esc_html_e('Horizontal', 'indeed-social-media');?></span>
		                            </td>
		                        </tr>
		                	</tbody>
		                </table>

		                <table class="form-table ism-counts">
			                <tbody>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('Display Counts', 'indeed-social-media');?>
										<span class="ism-info"><?php esc_html_e('Number of shares on each network will be displayed.', 'indeed-social-media');?></span>
		                            </th>
		                            <td>
		                                <?php
		                                    $checked = ism_checkSelected('true', $meta_arr['popup_display_counts'], 'checkbox');
		                                ?>
		                                <label>
		                                	<input type="checkbox" class="ism-switch" onClick="ism_check_and_h(this, '#popup_display_counts');" <?php echo $checked;?> />
		                                	<div class="switch ism-inline-block"></div>
		                                </label>
		                                <input type="hidden" value="<?php echo $meta_arr['popup_display_counts'];?>" name="popup_display_counts" id="popup_display_counts" />
		                            </td>
		                        </tr>
		                        <tr>
		                            <th scope="row">
		                               <?php esc_html_e('Display Full Name Of Social Network', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                                <?php
		                                    $checked = ism_checkSelected('true', $meta_arr['popup_display_full_name'], 'checkbox');
		                                ?>
		                                <label>
		                                	<input type="checkbox" onClick="ism_check_and_h(this, '#popup_display_full_name');" class="ism-switch" <?php echo $checked;?> />
		                                	<div class="switch ism-inline-block"></div>
		                                </label>
		                                <input type="hidden" value="<?php echo $meta_arr['popup_display_full_name'];?>" name="popup_display_full_name" id="popup_display_full_name" />
		                            </td>
		                        </tr>
						<tr>
                            <th scope="row">
                              <?php esc_html_e('Number of Columns', 'indeed-social-media');?>
                            </th>
                            <td>
                            	<select name="popup_no_cols" class="ism-columns">
								<?php
									for($ic = 0; $ic < 7; $ic++){
										if ($ic == 0){
												$label = 'Default';
										} else {
												$label = $ic.' Columns';
										}
										$selected = '';
	                            		if($meta_arr['popup_no_cols']== $ic){
																			$selected = 'selected="selected"';
																	}
										?>
	                            		<option value="<?php echo $ic;?>" <?php echo $selected;?> ><?php echo $label;?></option>
	                            	<?php
									}
								?>
								</select>
                            </td>
                        </tr>
						<tr>
                            <th scope="row">
                              <?php esc_html_e('Box Alignment', 'indeed-social-media');?>
                            </th>
                            <td>
                            	<select name="popup_box_align" class="ism-columns">
									<?php $selected = ism_checkSelected('left', $meta_arr[ 'popup_box_align' ], 'select'); ?>
	            					<option value="left" <?php echo $selected;?> >Left</option>
									<?php $selected = ism_checkSelected('center', $meta_arr[ 'popup_box_align' ], 'select'); ?>
	            					<option value="center" <?php echo $selected;?> >Center</option>
									<?php $selected = ism_checkSelected('right', $meta_arr[ 'popup_box_align' ], 'select'); ?>
	            					<option value="right" <?php echo $selected;?> >Right</option>
								</select>
                            </td>
                        </tr>
		                    </tbody>
		                </table>
		                <div class="submit">
		                    <input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
		                </div>
		            </div>
		        </div>


		        <?php
					//where to display
					$info = 'If none of them is not selected, the Social Icons will <strong>not show up</strong> using the "PopUp Display".';
					return_display_where_html( 'popup', $meta_arr, 'popup_submit_bttn', $info );
				?>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Position', 'indeed-social-media');?>:</label>
		            </h3>
		            <div class="inside">
		                <table class="form-table">
			                <tbody>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('Position', 'indeed-social-media');?>
										<span class="ism-info"><?php esc_html_e('Set the Box\'s icons position. Can be used positive or negative values.', 'indeed-social-media');?></span>
		                            </th>
		                            <td>
		                               <table>
										  <tr class="ism-cst-pos">
											  <td class="indeed_td_np" colspan="2">Top: <input type="number" value="<?php echo $meta_arr['popup_top_bottom_value'];?>" name="popup_top_bottom_value" class="indeed_number ism-numb"/>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_top_bottom_type'], '%', 'radio');?>
		                                      <input type="radio" class="ism-cstp" name="popup_top_bottom_type" value="%" <?php echo $checked;?> /><span class="indeedcrlabel ism-delimiter">% | </span>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_top_bottom_type'], 'px', 'radio');?>
		                                      <input type="radio" name="popup_top_bottom_type" value="px" <?php echo $checked;?>/><span class="indeedcrlabel">px</span>
		                                      </td>
		                                  </tr>
		                                  <tr>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_left_right'], 'left', 'radio');?>
		                                      <td class="indeed_td_np"><input type="radio"  name="popup_left_right" value="left" <?php echo $checked;?>/><span class="indeedcrlabel"><?php esc_html_e('Left', 'indeed-social-media');?></span></td>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_left_right'], 'right', 'radio');?>
		                                      <td class="indeed_td_np"><input type="radio"  name="popup_left_right" value="right" <?php echo $checked;?>/><span class="indeedcrlabel"><?php esc_html_e('Right', 'indeed-social-media');?></span></td>
		                                  </tr>
										  <tr>
											  <td class="indeed_td_np"><input type="number" value="<?php echo $meta_arr['popup_left_right_value'];?>" name="popup_left_right_value" class="indeed_number ism-numb" /></td>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_left_right_type'], '%', 'radio');?>
		                                      <td class="indeed_td_np"><input type="radio" class="ism-cstp" name="popup_left_right_type" value="%" <?php echo $checked;?> /><span class="indeedcrlabel ism-delimiter">% | </span>
		                                          <?php $checked = ism_checkSelected($meta_arr['popup_left_right_type'], 'px', 'radio');?>
		                                      <input type="radio"  name="popup_left_right_type" value="px" <?php echo $checked;?>/><span class="indeedcrlabel">px</span></td>
		                                  </tr>
		                               </table>
		                            </td>
		                        </tr>
								<tr>
		                            <th scope="row">
		                            </th>
		                            <td>
		                            </td>
		                        </tr>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('Width', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<input type="number" value="<?php echo $meta_arr['popup_width'];?>" name="popup_width" min="1" /> px
		                            </td>
		                        </tr>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('Height', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<input type="number" value="<?php echo $meta_arr['popup_height'];?>" name="popup_height" min="1" /> px
		                            </td>
		                        </tr>
								<tr>
		                            <th scope="row">
		                            </th>
		                            <td>
		                            </td>
		                        </tr>
		                        <tr>
		                            <th scope="row">
		                                <?php esc_html_e('Padding', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<input type="number" value="<?php echo $meta_arr['popup_padding'];?>" name="popup_padding" min="0" /> px
		                            </td>
		                        </tr>
		                    </tbody>
		                </table>
		                <div class="submit">
		                    <input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
		                </div>
		            </div>
		        </div>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Show Effect:', 'indeed-social-media');?></label>
		            </h3>
		            <div class="inside">
		                <table class="form-table">
			                <tbody>
		                        <tr>
		                            <td>
		                            	<select name="popup_show_effect" class="ism-popup">
		                            		<?php
		                            			$slide_arr = array(
		                            								'bounce' => 'Bounce',
		                            								'clip' => 'Clip',
		                            								'drop' => 'Drop',
		                            								'explode' => 'Explode',
		                            								'fadeIn' => 'Fade In',
		                            								'puff' => 'Puff',
		                            								'pulsate' => 'Pulsate',
		                            								'scale' => 'Scale',
		                            								'shake' => 'Shake',
		                            								'down'=>'Slide From Bottom',
		                            								'up'=>'Slide From Top',
		                            								'left'=>'Slide From Left',
		                            								'right'=>'Slide From Right',

		                            							  );
		                            			foreach($slide_arr as $k=>$v){
		                            				$selected = '';
		                            				if ($k==$meta_arr['popup_show_effect']){
																						$selected = 'selected="selected"';
																				}
		                            				?>
		                            					<option value="<?php echo $k;?>" <?php echo $selected;?> ><?php echo $v;?></option>
		                            				<?php
		                            			}
		                            		?>
		                            	</select>
		                            </td>
		                        </tr>
		                     </tbody>
		                 </table>
		                <div class="submit">
		                    <input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
		                </div>
		            </div>
		        </div>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('How To Show Up:', 'indeed-social-media');?></label>
		            </h3>
		            <div class="inside">
		                <table class="form-table">
			                <tbody>
		                        <tr>
		                            <td>
									<label><?php esc_html_e('When', 'indeed-social-media');?>:</label>
		                            	<select name="popup_show_up"  class="ism-popup">
		                            		<?php
		                            			$slide_arr = array( 'on_load'=>'On Load',
																	'leave'=>'Try to Leave the page',
		                            								'scroll_top'=>'Scroll Top',
		                            								'scroll_middle'=>'Scroll Middle',
		                            								'scroll_bottom'=>'Scroll Bottom' );
		                            			foreach($slide_arr as $k=>$v){
		                            				$selected = '';
		                            				if($k==$meta_arr['popup_show_up']){
																						$selected = 'selected="selected"';
																				}
		                            				?>
		                            					<option value="<?php echo $k;?>" <?php echo $selected;?> ><?php echo $v;?></option>
		                            				<?php
		                            			}
		                            		?>
		                            	</select>
		                            </td>
		                        </tr>
								<tr>
		                        	<td>
									</td>
		                        </tr>
		                        <tr>
		                        	<td>
		                        		<?php
		                        			$checked='';
		                        			if(isset($meta_arr['popup_show_once']) && $meta_arr['popup_show_once']==1){
																		$checked='checked="checked"';
																	}
		                        		?>
		                        		<input type="checkbox" onClick="check_and_h(this, '#popup_show_once');" <?php echo $checked;?> />
		                        		<input type="hidden" value="<?php echo $meta_arr['popup_show_once']?>" name="popup_show_once" id="popup_show_once" />

		                        	<?php esc_html_e('Show PopUp Only One Time Per Page. (Available only for Scroll Event!)', 'indeed-social-media');?></td>
		                        </tr>
		                    </tbody>
		                </table>


		                <div class="ism-delay">
						 <span class="ism-delay-label"><label>Delay:</label></span>
		            		<input type="number" value="<?php echo $meta_arr['popup_delay'];?>" name="popup_delay" min="0" class="ism-go-count-numb"/> <b>s</b>
		            	</div>
		                 <div class="clear"></div>

		            	<div class="ism-list-post">
						 <span class="ism-delay-label"><label>Autoclose after:</label></span>
		            		<input type="number" value="<?php echo $meta_arr['popup_slide_duration'];?>" name="popup_slide_duration" min="0" class="ism-go-count-numb"/> <b>s</b>
		            	</div>
		                <div class="clear"></div>

			            <div class="submit">
			            	<input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
			            </div>
		            </div>
		        </div>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Custom CSS:', 'indeed-social-media');?></label>
		            </h3>
		            <div class="inside">
		            	<div class="ism-list-post">
		            		<textarea name="popup_custom_css" class="ism-popup_css_cst"><?php echo $meta_arr['popup_custom_css'];?></textarea>
		            	</div>

			            <div class="submit">
			            	<input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
			            </div>
		            </div>
		        </div>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Custom Content:', 'indeed-social-media');?></label>
		            </h3>
		            <div class="inside">
		                <table class="form-table ism-cst-content-width">
			                <tbody>
			                	<tr>
		                            <th scope="row">
		                              <?php esc_html_e('Title', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<input type="text" name="popup_title" value="<?php echo $meta_arr['popup_title'];?>" />
									</td>
								</tr>
		                        <tr>
		                            <th scope="row">
		                              <?php esc_html_e('Above Content', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<?php
		                            		$settings = array( 'textarea_name' => 'popup_above_content', 'textarea_rows' => 4 );
		                            		wp_editor( stripslashes($meta_arr['popup_above_content']), 'popup_above_content', $settings );
		                            	?>
									</td>
								</tr>
		                        <tr>
		                            <th scope="row">
		                              <?php esc_html_e('Bellow Content', 'indeed-social-media');?>
		                            </th>
		                            <td>
		                            	<?php
		                            		$settings = array( 'textarea_name' => 'popup_bellow_content', 'textarea_rows' => 4 );
		                            		wp_editor( stripslashes($meta_arr['popup_bellow_content']), 'popup_bellow_content', $settings );
		                            	?>
									</td>
								</tr>
							</tbody>
						</table>
		                <div class="submit">
		                    <input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
		                </div>
					</div>
				</div>

				<?php
					//total counts metabox

					echo total_share_count_admin_box( 'popup', $meta_arr );

					//visits

					ism_return_views_section( 'popup', $meta_arr, 'popup_submit_bttn' );

					//after show

					ism_after_share_html( 'popup', $meta_arr, 'popup_submit_bttn' );
				?>

		        <div class="stuffbox-ism">
		            <h3>
		                <label><?php esc_html_e('Mobile', 'indeed-social-media');?>:</label>
		            </h3>
		            <div class="inside">
		                <table class="form-table">
			                <tbody>
		                        <tr>
		                            <th scope="row">
		                              <?php esc_html_e('Disable On Mobile:', 'indeed-social-media');?>
		                            </th>
		                            <td>
		    	                		<label>
		    	                			<?php
		    	                				$checked = '';
		    	                				if(isset($meta_arr['popup_disable_mobile']) && $meta_arr['popup_disable_mobile']==1){
																		$checked = 'checked="checked"';
																	}
		    	                			?>
		    	                			<input type="checkbox" class="ism-switch" onClick="check_and_h(this, '#popup_disable_mobile');" <?php echo $checked;?> />
		    	                		<div class="switch ism-inline-block"></div>
		    	                		</label>
		    	                		<input type="hidden" value="<?php echo $meta_arr['popup_disable_mobile'];?>" name="popup_disable_mobile" id="popup_disable_mobile" />
		                            </td>
		                        </tr>
		                     </tbody>
		                </table>
		                <div class="submit">
		                    <input type="submit" value="Save changes" name="popup_submit_bttn" class="button button-primary button-large" />
		                </div>
		            </div>
		       </div>
	</form>
</div>
</div>
